<?php
/*
 * création @Gilux 2019 pour ZwiiCMS
 * Version du 14 nov. 2020
 */
$dirname = $_GET['dirname'];
$path_files  = "./../../../".$dirname;

$gpx_path = glob($path_files."/*.gpx");
$gpx_file = basename($gpx_path[0]);
?>
<!DOCTYPE html>
<html lang="fr">
<head>
<meta charset="utf-8">
<title><?=str_replace(strrchr($gpx_file, "."), "", $gpx_file)?></title>
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">
<style>
html, body {
  width: 100vw;
  height: 100%;
  padding: 0;
  margin: 0;
  overflow: hidden;
}
body {
  background-color: #555;
}
#map, #elevation-div {
    width: 100%;
}
#map {
  height: 70vh
}
#elevation-div {
  height: 30%;
  font: 12px/1.5 Ubuntu, Arial, Helvetica, sans-serif;
  color: #eee;
  background: #555;
}
.elevation-summary span {
  line-height: 2;
}
.summaryvalue {
  margin-right: 10px;
}
span.download a {
  display: block;
  width: 100px;
  text-align: center;
  position: absolute;
  bottom: -3px;
  right: 20px;
  color: white;
  text-decoration: none;
}
span.download a:hover {
  background-color: #555;
  border: 1px outset darkred;
  bottom: 0;
  right: 23px;
}
.wpt-link-image {
  max-width: 240px;
  height: auto
}
</style>
<!-- leaflet-ui -->
<script src="leaflet/leaflet.js"></script>
<script src="leaflet/leaflet-ui-src.js"></script>
<!-- leaflet-elevation -->
<link rel="stylesheet" href="leaflet/leaflet-elevation.css" />
<script src="leaflet/leaflet-elevation.js"></script>
</head>

<body>
    <div id="map"></div>
    <div id="elevation-div"></div>
<script>
  // Full list options at "leaflet-elevation.js"
  var elevation_options = {

    // Default chart colors: theme lime-theme, magenta-theme, ...
    theme: "steelblue-theme",

    // Chart container outside/inside map container
    detached: true,

    // if (detached), the elevation chart container
    elevationDiv: "#elevation-div",

    // if (!detached) autohide chart profile on chart mouseleave
    autohide: false,

    // if (!detached) initial state of chart profile control
    collapsed: false,

    // if (!detached) control position on one of map corners
    position: "topright",

    // Autoupdate map center on chart mouseover.
    followMarker: true,

    // Chart distance/elevation units.
    imperial: false,

    // [Lat, Long] vs [Long, Lat] points. (leaflet default: [Lat, Long])
    reverseCoords: false,

    // Summary track info style: "line" || "multiline" || false,
    summary: 'line',

  };

  // Instantiate map (leaflet-ui)
  var map = new L.Map('map', { mapTypeId: 'topo', center: [44.85, 1.75], zoom: 5 });

  // Instantiate elevation control.
  var controlElevation = L.control.elevation(elevation_options).addTo(map);

  // Load track from url (allowed data types: "*.geojson", "*.gpx")
  controlElevation.load("<?=$path_files.'/'.rawurlencode($gpx_file)?>");

  // localisation
  var mylocale = {
    "Total Length: ": "Distance totale: ",
    "Max Elevation: ": "Altitude max: ",
    "Min Elevation: ": "Altitude min: ",
    "Altitude": "Altitude"
  };

  L.registerLocale('fr', mylocale);
  L.setLocale('fr');
</script>
</body>
</html>
