<?php
/*
 * création @Gilux 2019 pour ZwiiCMS
 * version du 17 nov. 2020
 */
$dirname = $_GET['dirname'];
$path_files  = "./../../../".$dirname;
$path_thumb  = "./../../../".str_replace("source", "thumb", $dirname);
$color = $_GET['color'];
?>
<!DOCTYPE html>
<html lang="fr">
<head>
<meta charset="utf-8">
<title><?=$dirname?></title>
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">
<link rel="stylesheet" href="leaflet/leaflet.css">
<link rel="stylesheet" href="leaflet/MarkerCluster.css">
<link rel="stylesheet" href="leaflet/MarkerCluster.Default.css">
<script src="leaflet/leaflet.js"></script>
<script src="leaflet/leaflet-ui-src.js"></script>
<script src="leaflet/leaflet-omnivore.min.js"></script>
<script src="leaflet/leaflet.markercluster.js"></script>
<style>
html, body{
    width: 100vw;
    height: 100%;
}
body {
    padding: 0;
    margin: 0;
}
#mapid {
    width: 100%;
    height: 100vh;
    background-color: black;
}
#mapid > img {
    display: block;
    max-height: 100vh;
    margin: auto;
}
</style>
</head>

<body>
<div id="mapid"> </div>
<?php
function getGps($exifCoord, $hemi) {
$degrees = count($exifCoord) > 0 ? gps2Num($exifCoord[0]) : 0;
$minutes = count($exifCoord) > 1 ? gps2Num($exifCoord[1]) : 0;
$seconds = count($exifCoord) > 2 ? gps2Num($exifCoord[2]) : 0;
$flip = ($hemi == 'W' or $hemi == 'S') ? -1 : 1;
return $flip * ($degrees + $minutes / 60 + $seconds / 3600);
}
function gps2Num($coordPart) {
$parts = explode('/', $coordPart);
if (count($parts) <= 0) return 0;
if (count($parts) == 1) return $parts[0];
return floatval($parts[0]) / floatval($parts[1]);
}

if (!file_exists($path_files."/datas.json")) {
    $tab  = array();
    $img_jpeg = ['jp**','JP**'];
    foreach ($img_jpeg as $jpeg) {
    foreach (glob($path_files."/*.".$jpeg) as $filename) {
        $exif = @exif_read_data($filename, 0, true) ? exif_read_data($filename) : false;

        if(isset($exif['GPSLongitude'][0])) {
            $lon = getGps($exif['GPSLongitude'], $exif['GPSLongitudeRef']);
            $lat = getGps($exif['GPSLatitude'], $exif['GPSLatitudeRef']);

            $name = basename($filename);
            $tab['file'][] = array('name' => $name,
                                'lon' => $lon,
                                'lat' => $lat);
        }
    }
}
    if ((count($tab)) > 0) {
    file_put_contents($path_files."/datas.json", json_encode($tab));
    }
    else {
    file_put_contents($path_files."/nodata.txt", "Aucune donnée GPS EXIF");
    }
}
else {
// lecture des coordonnées
$tab = json_decode(file_get_contents($path_files."/datas.json"), true);
}
?>

<script>
var mymap = new L.map('mapid', { mapTypeId: 'streets', center: [44.85, 1.75], zoom: 5, maxZoom: 17 });

var markers = L.markerClusterGroup();

<?php
echo "var couleur = '$color';";
?>

var customLayer = L.geoJson(null, {
    style: function(feature) {
        return { color: couleur };
    }
});

<?php
// création des "markers"
if (isset($tab['file'])) {
    foreach( $tab['file'] as $key => $val ) {
        $img = $val['name'];
        $url_img = $path_files."/".$img;
        $miniature = "mini_".strtolower($img );
        $url_mini = $path_thumb."/".$miniature;

        $size = getimagesize($url_mini);
        if ($size[0] > $size[1]) { $large = "240"; } else { $large = "180"; }

        echo "var marker = L.marker([$val[lat],$val[lon]]).
        bindPopup('<img src=\"".$url_mini."\" style=\"width:".$large."px\" alt=\"localisation\" onClick=\"document.getElementById(\'mapid\').innerHTML=\'<img src=".$url_img.">\';\" title=\"Afficher l\'image\">');";

        echo "marker.on('mouseover', function (e) {
            this.openPopup();
        });
        markers.addLayer(marker).addTo(mymap);";
    }
}

// ajout des fichiers gpx et kml à la carte
$t_ext = array('gpx','kml');
foreach ($t_ext as $ext) {
    foreach (glob($path_files."/*.".$ext) as $filename) {
        $gpx_file = basename($filename);
        echo "omnivore.$ext('$path_files/$gpx_file', null, customLayer).addTo(mymap);\n";
    }
}
?>
mymap.fitBounds(markers.getBounds());
</script>
</body>
</html>
